```cpp
ll fpro(ll x,ll y,ll p = 1e9 + 7)
{
    ll z=(double)x/p*y;
    ll res=(ull)x*y-(ull)z*p;
    return (res+p)%p;
}

ll fpow(ll a,ll n,ll mod = 1e9 + 7)
{
    ll res = 1;
    while(n)
    {
        if(n & 1)
        {
            res = res % mod * a % mod;
        }
        a = a % mod * a % mod;
        n >>= 1;
    }
    return res % mod; 
}

ll fpow(ll a,ll n,ll mod) {
//模数过大可能爆ll时使用
	ll res=1;
	while(n) {
		if(n&1) {
			res=fpro(res%mod,a%mod,mod);
		}
		a=fpro(a%mod,a%mod,mod);
		n>>=1;
	}
	return res%mod;
}

long long fpow(long long a, long long n, long long mod)
{
    long long res = 1;
    while (n)
    {
        if (n & 1) res = (lll)res * a % mod;
        a = (lll)a * a % mod;
        n >>= 1;
    }
    return res;
}
```

