```cpp
long long fpro(long long x,long long y,long long p)
{
    long long z=(long double)x/p*y;
    long long res=(unsigned long long)x*y-(unsigned long long)z*p;
    return (res+p)%p;
}

bool MillerRabin(ll n)
{//快速素数判断
    ll i, j, a, x, y, t, u, s = 10;
    if (n == 2) return true;
    if (n < 2 || !(n & 1))  return false;
    for (t = 0, u = n - 1; !(u & 1); t++, u >>= 1); //n-1=u*2^t
    for (i = 0; i < s; i++) 
    {
        a = rand() % (n - 1) + 1;
        x = fpow(a, u, n);
        for (j = 0; j < t; j++) 
        {
            y = fpro(x, x, n);
            if (y == 1 && x != 1 && x != n - 1)
                return false;
            x = y;
        }
        if (x != 1)
            return false;
    }
    return true;
}
```

