```cpp
struct mat
{//下标均从1开始
    ll a[200][200];
    int m, n;
    ll* operator[](int i)
    {
        return a[i];
    }
    mat operator*(mat s)
    {
        mat res;
        for (int k = 1; k <= m; k++) 
        {
            for (int i = 1; i <= s.n; i++)
            {
                res[k][i] = 0;
                for (int j = 1; j <= n; j++) 
                {
                    res[k][i] += a[k][j] * s[j][i];
                    res[k][i] %= mod;
                }
            }
        }
        res.m = m;
        res.n = s.n;
        return res;
    }
    mat emat(int n)
    {
        mat res;
        mfor(i, 1, n)
        {
            mfor(j, 1, n)
            {
                if (i == j) res[i][j] = 1;
                else res[i][j] = 0;
            }
        }
        res.m = res.n = n;
        return res;
    }
    mat fpow(mat a, long long n)
    //在fib中，f[i]=1*f[i-1]+1*f[i-2],f[i-1]=1*f[i-1]+0*f[i-2],所以fib[n]=({{1,1},{1,0}}^n)[2][1]
    {
        if (n == 0) return emat(a.m);
        else if (n & 1) return a * fpow(a, n - 1);
        else
        {
            mat num = fpow(a, n / 2);
            return num * num;
        }
    }
};
```

