```cpp
struct linervectors
{
    ll d[62];
    int tot;
    int n;
    void add(ll x)
    {
        for (int i = 60; i >= 0; i--)    //1e18范围内够用
        {
            if (x & (1LL << i))
            {
                if (d[i]) x ^= d[i];
                else
                {
                    d[i] = x;
                    tot++;
                    break;
                }
            }
        }
    }
    ll maxxor()
    {
        ll res = 0;
        for (int i = 60; i >= 0; i--)
        {
            if ((res ^ d[i]) > res) res ^= d[i];
        }
        return res;
    }
    ll minxor()
    {//若有不能插入线性基的元素则最小值为0
        if (tot < n) return 0;
        ll res = d[60];
        for (int i = 60; i >= 0; i--)
        {
            res = min(res, d[i]);
        }
        return res;
    }
    ll kthmin(ll k)
    {
        if (k == 1 && tot < n) return 0;    //若有元素不能插入线性基则第一小为0
        if (tot < n) k--;   //线性基不能异或出0
        for (int i = 1; i <= 60; i++)
        {
            for (int j = 1; j <= i; j++)
            {
                if (d[i] & (1LL << (j - 1))) d[i] ^= d[j - 1];
            }
        }//处理简化线性基
        ll res = 0;
        for (int i = 0; i <= 60; i++)
        {
            if (d[i])
            {
                if (k & 1) res ^= d[i];
                k >>= 1;
            }
        }
    }
    bool canxor(ll x)
    {//判断一个数是否能被原序列（即add过所有元素的序列）异或得到
        for (int i = 60; i >= 0; i--)    //1e18范围内够用
        {
            if (x & (1LL << i))
            {
                if (d[i]) x ^= d[i];
                else return false;
            }
        }
        return true;
    }
};
```

