```cpp
ll fac[200010];

void getfac(int n, const ll mod = 1e9 + 7)
{
    fac[0] = 1;
    for (int i = 1; i <= n; i++) fac[i] = fac[i - 1] * i % mod;
}


template<class T>
ll cantor(T& s, const ll mod = 1e9 + 7)
{//s为输入的排列，下标从1开始
    ll res = 1;
    int sz = (int)s.size();
    for (int i = 1; i < sz; i++)
    {
        int cnt = 0;
        for (int j = i + 1; j < sz; j++)
        {
            if (s[j] < s[i]) cnt++;
        }
        res += cnt * fac[sz - i - 1] % mod;
        res %= mod;
    }
    return res;
}
```

